Subject: bug#49803: 27.2; Mouse wheel on MacOS is reported as mouse-4 and mouse-5, but Emacs mwheel seems to use wheel-up/wheel-down instead

From: Eli Zaretskii <[email-masked]>
Date: Wed, 11 Aug 2021 15:03:01 +0300

> From: Robert Pluim <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Wed, 11 Aug 2021 11:24:54 +0200
> 
> I was unclear: I hadn't figured out how to get the relevant terminal
> programs to generate either wheel-up/down or mouse-4/5. It looks like
> iterm2 sends mouse events using the xterm protocol, which xt-mouse
> then posts as mouse-4/5 events. I guess we could modify xt-mouse to
> optionally send them as wheel-up/down instead, but that feels like a hack.

Does the xterm protocol allow to report wheel events, or does it only
allow to report mouse-click events?  If the latter, I don't see how
you could map the events in any way different from what we have now,
i.e. via a user-controlled setting.

>     Eli> I guess the difference is between systems where the GUI API tells us
>     Eli> explicitly whether its a wheel-up/down event, and systems where we
>     Eli> just get "button number N" event.  Or something like that.
> 
> This is using emacs -nw, so the gui api is not involved.

The "GUI" part is not important in what I wrote, you can replace it
with "UI" or even with nothing.  I was talking about the APIs we use
to access the mouse events.